#include <iostream>
#include <cmath>
using namespace std;

struct F {
    long long d, x, y;
    F(long long dd, long long xx, long long yy):
        d(dd), x(xx), y(yy) {}
};
F euclid(long long a, long long b) {
    if (!b) return F(a, 1, 0);
    F r(euclid(b, a%b));
    return F(r.d, r.y, r.x-(a/b)*r.y);
}

long long gcd(long long a, long long b) {
    if (!b) return a;
    return gcd(b, a%b);
}
long long lcm(long long a, long long b) {
    return a*(b/gcd(a, b));
}
int main() {
    int n, p; cin>>p;
    for (int t=0; t<p; t++) {
        cin>>n; 
        long long a1, b1, a2, b2;
        cin>>a1>>b1; bool c=true;
        for (int i=1; i<n; i++) {
            cin>>a2>>b2;
            if (i%2) b2=(a2-b2)%a2;
            if (c) {
                F x=euclid(a1, -a2);
                if ((b2-b1)%x.d!=0) {
                    c=false; continue;
                }
                
                long long l=a2/gcd(a1, a2), h=((b2-b1)/x.d)%l;
                long long e, r=x.x*h%l;
                if (r<0) {
                    e=abs(r)/l+1; r+=e*l;
                }
                r%=l; b1+=a1*r;
                a1=lcm(a1, a2);
                //cout<<a1<<" "<<b1<<" : "<<r<<endl;
            }
        }
        if (!c) cout<<"Impossible"<<endl;
        else cout<<b1<<endl;
    }
}
